package dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.google.common.base.Preconditions;
import com.google.common.collect.ImmutableSet;
import com.mojang.datafixers.kinds.App;
import com.mojang.datafixers.kinds.Applicative;
import com.mojang.serialization.Codec;
import com.mojang.serialization.codecs.RecordCodecBuilder;
import dev.shadowsoffire.apotheosis.Apotheosis;
import dev.shadowsoffire.apotheosis.adventure.affix.Affix;
import dev.shadowsoffire.apotheosis.adventure.loot.LootCategory;
import dev.shadowsoffire.apotheosis.adventure.loot.LootRarity;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.GemClass;
import dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.GemBonus;
import java.util.Map;
import java.util.function.Function;
import net.minecraft.ChatFormatting;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.util.StringUtil;
import net.minecraft.world.damagesource.DamageSource;
import net.minecraft.world.entity.LivingEntity;
import net.minecraft.world.item.ItemStack;

public class LeechBlockBonus extends GemBonus {
  public static Codec<dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special.LeechBlockBonus> CODEC;
  
  protected final Map<LootRarity, Data> values;
  
  static {
    CODEC = RecordCodecBuilder.create(inst -> inst.group((App)LootRarity.mapCodec(Data.CODEC).fieldOf("values").forGetter(())).apply((Applicative)inst, dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special.LeechBlockBonus::new));
  }
  
  public LeechBlockBonus(Map<LootRarity, Data> values) {
    super(Apotheosis.loc("leech_block"), new GemClass("shield", ImmutableSet.of(LootCategory.SHIELD)));
    this.values = values;
  }
  
  public float onShieldBlock(ItemStack gem, LootRarity rarity, LivingEntity entity, DamageSource source, float amount) {
    Data d = this.values.get(rarity);
    if (amount <= 2.0F || Affix.isOnCooldown(getCooldownId(gem), d.cooldown, entity))
      return amount; 
    entity.m_5634_(amount * d.healFactor);
    Affix.startCooldown(getCooldownId(gem), entity);
    return amount;
  }
  
  public Codec<? extends GemBonus> getCodec() {
    return (Codec)CODEC;
  }
  
  public Component getSocketBonusTooltip(ItemStack gem, LootRarity rarity) {
    Data d = this.values.get(rarity);
    MutableComponent mutableComponent = Component.m_237110_("affix.apotheosis.cooldown", new Object[] { StringUtil.m_14404_(d.cooldown) });
    return (Component)Component.m_237110_("bonus." + getId() + ".desc", new Object[] { Affix.fmt(d.healFactor * 100.0F), mutableComponent }).m_130940_(ChatFormatting.YELLOW);
  }
  
  public dev.shadowsoffire.apotheosis.adventure.socket.gem.bonus.special.LeechBlockBonus validate() {
    Preconditions.checkNotNull(this.values);
    this.values.forEach((k, v) -> {
          Preconditions.checkNotNull(k);
          Preconditions.checkNotNull(v);
        });
    return this;
  }
  
  public boolean supports(LootRarity rarity) {
    return this.values.containsKey(rarity);
  }
  
  public int getNumberOfUUIDs() {
    return 0;
  }
}
